/* clientstr.h -*- C++ -*- client string interface
 * Rob Earhart
 * $Id: clientstr.h,v 1.3 1998/03/09 00:57:53 rob Exp $
 */
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#ifndef ACAP_CLIENTSTR_H
#define ACAP_CLIENTSTR_H

#include <iostream.h>
#include "str.h"

// This is a little utility wrapper; when written, it formats the
// string as appropriate for sending over an ACAP connection (much
// better than the nonsense we were using before...)
class ClientStr {
public:
  ClientStr(const String &_str) : str(&_str) {}
  ClientStr(const String *_str) : str(_str) {}
  friend ostream &operator<<(ostream &out, const ClientStr &str);
  static ostream &Send(ostream &out, ...);
private:
  static bool contains_unsafe_chars(const String *str);
  const String *str;
};

#endif // ACAP_CLIENTSTR_H
