/* lex.acap.h -*- C++ -*- acap lexer interface
 * Rob Earhart
 * $Id: lex.acap.h,v 1.2 1998/02/18 21:18:31 rob Exp $
 */
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#ifndef ACAP_LEX_ACAP_H
#define ACAP_LEX_ACAP_H

#include "token.h"

#ifndef ACAP_HAVE_ACAP_LEXER
#define ACAP_HAVE_ACAP_LEXER
#ifdef yyFlexLexer
#undef yyFlexLexer
#endif // yyFlexLexer

#define yyFlexLexer acapFlexLexer
#include <FlexLexer.h>
#endif // ACAP_HAVE_ACAP_LEXER

class Conn;

class ACAPLexer : public acapFlexLexer {
public:
  ACAPLexer(Conn *_conn, istream *in = 0, ostream *out = 0)
    : acapFlexLexer(in, out), conn(_conn), literal_length(0) {}
  int yylex();
  void ExpectingTag();
  void Resync();
  String Literal();
  String Quoted();
private:
  Conn *conn;
  bool nonsync_literal;
  size_t literal_length;
};


#endif // ACAP_LEX_ACAP_H
