/* mutex.h -*- C++ -*- mutex interface
 * Rob Earhart
 * $Id: mutex.h,v 1.1 1998/02/18 21:18:53 rob Exp $
 */
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#ifndef ACAP_MUTEX_H
#define ACAP_MUTEX_H

// This is just a simple wrapper class to provide a mutex, so that
// objects of the class (and inheriting from the class) can be
// easily locked...

#include <pthread.h>

class Mutex {
public:
  Mutex() {
    pthread_mutex_init(&mut, NULL);
  }
  ~Mutex() {
    pthread_mutex_destroy(&mut);
  }
  void Lock() { pthread_mutex_lock(&mut); }
  void Unlock() { pthread_mutex_unlock(&mut); }

  // Useful for things like the Cond class...
  operator pthread_mutex_t *() { return &mut; }
private:
  pthread_mutex_t mut;
};

#endif // ACAP_MUTEX_H
